﻿namespace UMK_Zespolone
{
    using System.Numerics;

    public class RównanieKwadratowe
    {        
        private Complex a, b, c;

        public RównanieKwadratowe(Complex a, Complex b, Complex c)
        {
            this.a = a;
            this.b = b;
            this.c = c;
            rozwiąż();
        }

        private bool trzebaObliczyćRozwiązania = true;

        public Complex A
        {
            get
            {
                return a;
            }
            set
            {
                a = value;
                trzebaObliczyćRozwiązania = true;
            }
        }

        public Complex B
        {
            get
            {
                return b;
            }
            set
            {
                b = value;
                trzebaObliczyćRozwiązania = true;
            }
        }

        public Complex C
        {
            get
            {
                return c;
            }
            set
            {
                c = value;
                trzebaObliczyćRozwiązania = true;
            }
        }

        private Complex x1, x2;

        public Complex X1
        {
            get
            {
                rozwiąż();
                return x1;
            }
        }

        public Complex X2
        {
            get
            {
                rozwiąż();
                return x2;
            }
        }

        private void rozwiąż()
        {
            if (!trzebaObliczyćRozwiązania) return;
            Complex delta = b * b - 4 * a * c;
            Complex pieriastekZDelty = Complex.Sqrt(delta);
            x1 = (-b - pieriastekZDelty) / (2 * a);
            x2 = (-b + pieriastekZDelty) / (2 * a);
            trzebaObliczyćRozwiązania = false;
        }

        public override string ToString()
        {
            return $"Wyniki: x1={X1}, x2={X2}";            
        }
    }
}
