﻿using System.Numerics;
using System.Runtime.InteropServices;
using UMK;

// See https://aka.ms/new-console-template for more information
Console.WriteLine("Hello, World!");

Console.WriteLine(new UMK_Zespolone.RównanieKwadratowe(1, 2, 1));
Console.WriteLine(new UMK_Zespolone.RównanieKwadratowe(1, 0, -1));
Console.WriteLine(new UMK_Zespolone.RównanieKwadratowe(1, 1, 1));
Console.WriteLine(new UMK_Zespolone.RównanieKwadratowe(Complex.ImaginaryOne, new Complex(0,2), Complex.ImaginaryOne));

BigInteger bi = new BigInteger();
return;

void wyświetlWyniki(RównanieKwadratowe rk)
{
    Console.WriteLine(rk);
}

RównanieKwadratowe rk1 = new RównanieKwadratowe(1, 2, 1);
wyświetlWyniki(rk1);

RównanieKwadratowe rk2 = new RównanieKwadratowe(1, 0, -1);
wyświetlWyniki(rk2);

RównanieKwadratowe rk3 = new RównanieKwadratowe(1, 1, 1);
wyświetlWyniki(rk3);

//kernel32.dll
[DllImport("kernel32.dll")]
extern static ulong GetTickCount64();

long N = 10000000;
Random r = new Random();
RównanieKwadratowe rk = new RównanieKwadratowe(1, 2, 1);
long start = Environment.TickCount64;
ulong start1 = GetTickCount64();
for (long i = 0; i < N; ++i)
{    
    rk.A = 100.0 * r.NextDouble();
    rk.B = 100.0 * r.NextDouble();
    rk.C = 100.0 * r.NextDouble();
    //wyświetlWyniki(rk);
    double? x1 = rk.X1;
    double? x2 = rk.X2;
}
long koniec = Environment.TickCount64;
ulong koniec1 = GetTickCount64();
Console.WriteLine(koniec - start);
Console.WriteLine(koniec1 - start1);

