﻿namespace UMK
{
    public class RównanieKwadratowe
    {
        private double a, b, c;

        public RównanieKwadratowe(double a, double b, double c)
        {
            this.a = a;
            this.b = b;
            this.c = c;
            rozwiąż();
        }

        private bool trzebaObliczyćRozwiązania = true;

        public double A
        {
            get
            {
                return a;
            }
            set
            {
                a = value;
                trzebaObliczyćRozwiązania = true;
                //rozwiąż();
            }
        }

        public double B
        {
            get
            {
                return b;
            }
            set
            {
                b = value;
                trzebaObliczyćRozwiązania = true;
                //rozwiąż();
            }
        }

        public double C
        {
            get
            {
                return c;
            }
            set
            {
                c = value;
                trzebaObliczyćRozwiązania = true;
                //rozwiąż();
            }
        }

        //public double? X1 { get; private set; } = null;
        //public double? X2 { get; private set; } = null;

        private double? x1, x2;

        public double? X1
        {
            get
            {
                rozwiąż();
                return x1;
            }
        }

        public double? X2
        {
            get
            {
                rozwiąż();
                return x2;
            }
        }

        private void rozwiąż()
        {
            if (!trzebaObliczyćRozwiązania) return;
            double delta = b * b - 4 * a * c;
            if (delta >= 0)
            {
                double pieriastekZDelty = Math.Sqrt(delta);
                x1 = (-b - pieriastekZDelty) / (2 * a);
                x2 = (-b + pieriastekZDelty) / (2 * a);
            }
            else
            {
                x1 = null;
                x2 = null;
            }
            trzebaObliczyćRozwiązania = false;
        }

        public override string ToString()
        {
            //potencjalny błąd!
            if (x1.HasValue) return $"Wyniki: x1={X1}, x2={X2}";
            else return "Równanie nie ma rozwiązań";
        }
    }
}
